#include "DxLib.h"

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int WIN_W = 1280, WIN_H = 720;

	SetOutApplicationLogValidFlag(FALSE);
	SetAlwaysRunFlag(TRUE);
	SetWindowSizeChangeEnableFlag(TRUE);
	SetFullScreenResolutionMode(DX_FSRESOLUTIONMODE_DESKTOP);
	SetWindowText("");
	ChangeWindowMode(TRUE);
	SetGraphMode(WIN_W, WIN_H, 32);
	SetWaitVSyncFlag(FALSE);
	SetWindowStyleMode(7);
	SetBackgroundColor(0x11, 0x11, 0x11);
	if (DxLib_Init() == -1) return 0;
	SetDrawScreen(DX_SCREEN_BACK);
	DWORD a = 0;
	LONGLONG PrevTime2 = GetNowHiPerformanceCount();
	int PrevTime = GetNowCount();
	int FPS = 0;
	int FPSCounter = 0;
	while (ProcessMessage() == 0 && CheckHitKey(KEY_INPUT_ESCAPE) == 0)
	{
		LONGLONG NowTime2 = GetNowHiPerformanceCount();

		if ( 1000000 / 60 < NowTime2 - PrevTime2 )
		{
			FPSCounter++;
			int NowTime = GetNowCount();
			if (NowTime - PrevTime > 1000)
			{
				PrevTime = NowTime;
				FPS = FPSCounter;
				FPSCounter = 0;
			}

			PrevTime2 = NowTime2;
			DrawBox(10, 10, 200, 200, a++, 1);
			DrawFormatString(0, 0, GetColor(255, 255, 255), "%d", FPS );
			ScreenFlip();
			ClearDrawScreen();
		}
	}

	return 0;	// ソフトの終了
}
